/* -*- mode: c; mode: abbrev; mode: auto-fill; -*- */

/*
 * pceLCD(Circle|Ellipse) ̂
 * by Autch, 2006.10.19 *public domain*
 *
 * N A Ń_ȐFƃTCY̐^~`A
 *        B Ń_ȐFƃTCY̑ȉ~`A
 *        SELECT ŉʏ
 */

#include <piece.h>
#include <stdlib.h>
#include "pcecircle.h"

static unsigned char vScreen[128 * 88];
int g_nDirty; /* _[eBtO */

#define MarkDirty() (g_nDirty = 1)   /* Refresh() Kv */
#define ClearDirty() (g_nDirty = 0)  /* Refresh()  */

int rnd(int n) { return rand() % n; }

/* `悵ƂC[W] */
void Refresh()
{
  if(!g_nDirty) return;
  pceLCDTrans();
  ClearDirty();
}

/* C[W */
void Cls()
{
  memset(vScreen, 0, 128 * 88);
  MarkDirty();
}

void pceAppInit()
{
  g_nDirty = 1;
  pceLCDDispStop();
  pceLCDSetBuffer(vScreen);
  pceAppSetProcPeriod(20);
  Cls();

  srand(pceTimerGetCount());

  Refresh();
  pceLCDDispStart();
}

void pceAppProc(int cnt)
{
  if(pcePadGet() & TRG_A)
  {
    /*
     * rnd(3) + 1: nɔ~`̂h
     * rnd(88 / 2): a 44 ܂łɐΕKʓɌ
     */
    pceLCDCircle(rnd(3) + 1, rnd(128), rnd(88), rnd(88 / 2));
    MarkDirty();
  }
  if(pcePadGet() & TRG_B)
  {
    pceLCDEllipse(rnd(3) + 1, rnd(128), rnd(88), rnd(128 / 2), rnd(88 / 2));
    MarkDirty();
  }
  if(pcePadGet() & TRG_D)
    Cls();

  Refresh();
}

void pceAppExit()
{
}
